/*
 * =================================================
 * =   This file belongs to the lab session for    =
 * = Rechnerarchitektur 2020 @ TU Dortmund Germany =
 * =================================================
 */

// This programm has to be compiled with -lpthread option

#include <stdio.h>
#include <stdlib.h>

// The pthread header contains all the required functionality and has to be included here
#include <pthread.h>

/**
 * pthread expects a specific signature for the functions,
 * it executes in parallel. The functions have to accept a
 * parameter with the type void * and have to return an
 * instance of void *
 */
void *func1(void *arg) {
  for(int i = 0; i < 10000; i++) {
    printf("I'm func1, currently at iteration %d\n", i);
  }
  //We do not use the specific return value
  return NULL;
}

void *func2(void *arg) {
  for(int i = 0; i < 10000; i++) {
    printf("I'm func2, currently at iteration %d\n", i);
  }
  return NULL;
}

void *func3(void *arg) {
  for(int i = 0; i < 10000; i++) {
    printf("I'm func3, currently at iteration %d\n", i);
  }
  return NULL;
}

void *func4(void *) {
  for(int i = 0; i < 10000; i++) {
    printf("I'm func4, currently at iteration %d\n", i);
  }
  return NULL;
}

int main() {

  // Setup thread data structure, created threads have to saved in
  // a variable from type pthread_t
  pthread_t threads[4];

  // Create threads: The pthread_create function takes a pointer
  // to the thread vaiable as a first argument, parameters for
  // the thread as second argument, the thread function as a third
  // argument and the parameter for the thread function as the last
  // argument
  if( pthread_create(&threads[0], NULL, &func1, NULL) != 0) {
    printf("Could not create thread 0\n");
    return EXIT_FAILURE;
  }
  if( pthread_create(&threads[1], NULL, &func2, NULL) != 0) {
    printf("Could not create thread 1\n");
    return EXIT_FAILURE;
  }
  if( pthread_create(&threads[2], NULL, &func3, NULL) != 0) {
    printf("Could not create thread 2\n");
    return EXIT_FAILURE;
  }
  if( pthread_create(&threads[3], NULL, &func4, NULL) != 0) {
    printf("Could not create thread 3\n");
    return EXIT_FAILURE;
  }

  // The threads all run in parallel, the main thread (here), also.
  // Therefore, we need to wait for all threads to finish, to not
  // end the entire program too early.
  pthread_join(threads[0], NULL);
  pthread_join(threads[1], NULL);
  pthread_join(threads[2], NULL);
  pthread_join(threads[3], NULL);

  return 0;
}
